include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "div_mod.ma".
include "leibniz.ma".
include "logic.ma".
include "nat.ma".
include "primes.ma".
axiom gcd_aux : nat -> nat -> nat -> nat.
axiom gcd_aux_body : nat -> nat -> nat -> nat.
axiom axiom_gcd_aux : \forall (p:nat). (equal) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p).
definition eq_gcd_aux : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p) := \lambda p : nat. ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux)  p)) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p)) ((axiom_gcd_aux) (p)).
definition sym_eq_gcd_aux : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p) ((gcd_aux)  p) := \lambda p : nat. ((((sym_leibniz) (nat -> nat -> nat)) ((gcd_aux)  p)) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p)) ((eq_gcd_aux) (p)).
axiom axiom_gcd_aux_body_S : \forall (p:nat). (equal) (nat -> nat -> nat) ((gcd_aux_body)  ((S)  p)) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)).
definition eq_gcd_aux_body_S : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((gcd_aux_body)  ((S)  p)) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)) := \lambda p : nat. ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  ((S)  p))) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m))) ((axiom_gcd_aux_body_S) (p)).
definition sym_eq_gcd_aux_body_S : \forall (p:nat). (leibniz) (nat -> nat -> nat) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m)) ((gcd_aux_body)  ((S)  p)) := \lambda p : nat. ((((sym_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  ((S)  p))) (\lambda m : nat. \lambda n : nat. (match_bool_type) (nat) n ((gcd_aux)  p n ((mod)  m n)) ((dividesb)  n m))) ((eq_gcd_aux_body_S) (p)).
definition divides_to_gcd_aux : \forall (p:nat). \forall (m:nat). \forall (n:nat). ((lt)  (O)  p) -> ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) ((gcd_aux)  p m n) n := \lambda p : nat. \lambda m : nat. \lambda n : nat. \lambda posp : (lt)  (O)  p. (((((lt_O_n_elim) (p)) (posp)) (\lambda j__ : nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) ((gcd_aux)  j__ m n) n)) (\lambda l : nat. (((sym_eq_gcd_aux) ((S)  l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) ((((((sym_eq_filter_nat_type_S) (nat -> nat -> nat)) ((gcd_aux_body) )) (l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) ((((sym_eq_gcd_aux_body_S) (l)) (\lambda y : nat -> nat -> nat. ((lt)  (O)  n) -> ((divides)  n m) -> (eq) (nat) (y m n) n)) (\lambda posn : (lt)  (O)  n. (\lambda divnm : (divides)  n m. (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) n ((gcd_aux)  l n ((mod)  m n)) x) n)) ((((((sym_eq_match_bool_type_true) (nat)) (n)) ((gcd_aux)  l n ((match_nat_type) (nat) m (\lambda p0 : nat. (mod_aux)  m m p0) n))) (\lambda y : nat. (eq) (nat) y n)) (((refl) (nat)) (n)))) ((dividesb)  n m)) (((((divides_to_dividesb_true) (n)) (m)) (posn)) (divnm))))))))).
